<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>StateSummary.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">StateSummary.java</span></div><h1>StateSummary.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

/**
 * This class encapsulates the state comparison logic. Specifically,
 * how two different states are compared.
 */
public class StateSummary {
	private long currentEpoch;
	private long lastZxid;
<span class="fc" id="L28">	public StateSummary(long currentEpoch, long lastZxid) {</span>
<span class="fc" id="L29">		this.currentEpoch = currentEpoch;</span>
<span class="fc" id="L30">		this.lastZxid = lastZxid;</span>
<span class="fc" id="L31">	}</span>
	
	public long getCurrentEpoch() {
<span class="fc" id="L34">		return currentEpoch;</span>
	}
	
	public long getLastZxid() {
<span class="fc" id="L38">		return lastZxid;</span>
	}
	
	public boolean isMoreRecentThan(StateSummary ss) {
<span class="pc bpc" id="L42" title="2 of 6 branches missed.">		return (currentEpoch &gt; ss.currentEpoch) || (currentEpoch == ss.currentEpoch &amp;&amp; lastZxid &gt; ss.lastZxid);</span>
	}
	@Override
	public boolean equals(Object obj) {
<span class="nc bnc" id="L46" title="All 2 branches missed.">		if (!(obj instanceof StateSummary)) {</span>
<span class="nc" id="L47">			return false;</span>
		}
<span class="nc" id="L49">		StateSummary ss = (StateSummary)obj;</span>
<span class="nc bnc" id="L50" title="All 4 branches missed.">		return currentEpoch == ss.currentEpoch &amp;&amp; lastZxid == ss.lastZxid;</span>
	}
	
	@Override
	public int hashCode() {
<span class="nc" id="L55">		return (int)(currentEpoch ^ lastZxid);</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>